##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName (not the PkgFileName)
# sampledir (sampledir)		= pkg-dirname (under /usr/local/ = ksm-xxx)
# sampleconf (sampleconf)	= config file name (no path, no extension)
# sampled (sampled)		= the daemon (rc-script, rc-link, script.sh, systemd.service)
# ksm-sample (ksm-sample)	= special name starting with 'ksm-'
# sample (sample)		= all others (xxx, togglexxx)
##############################################################################

# Specfile for KSM-RPM

%define name		ksm-rpm
%define version		0.0.1
%define release		1.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs to handle rpm packages
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-rpmpkg,ksm-rpmcapab
Requires:	ksm-lib-sh >= 3.0.2-0.5.0
#Provides:	ksmrpmd
#Conflicts:	ksmrpmd-other,libksm-rpm == 0.0.0
#Obsoletes:	myksmrpmd

%description
This package contains programs to handle rpm packages.
The package contains the following programs:

 rpmchk, rpmdeps1, rpminfo, rpmprovides, rpmrequires

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/ksmrpm.conf
#%config %{_confdir}/ksmrpm.conf
#%config %{_scnfdir}/ksmrpm
#%attr(644,root,root)%{_confdir}/ksmrpm.conf
#%attr(644,root,root)%{_scnfdir}/ksmrpm

#%attr(744,root,root)%{_rcdir}/ksmrpmd
#%attr(777,root,root)%{_sbindir}/rcksmrpmd
#%attr(744,root,root)%{_sbindir}/ksmrpmd.sh

%attr(755,root,root)%{_bindir}/rpmchk
%attr(755,root,root)%{_bindir}/rpmdeps1
%attr(755,root,root)%{_bindir}/rpminfo
%attr(755,root,root)%{_bindir}/rpmman
%attr(755,root,root)%{_bindir}/rpmprovides
%attr(755,root,root)%{_bindir}/rpmrequires

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/ksmrpmd.rc
#%{_datadir}/ksmrpmd.service

#/usr/share/applications/ksm-rpm.desktop

#%{_icondir}/16x16/apps/ksm-rpm.png
#%{_icondir}/22x22/apps/ksm-rpm.png
#%{_icondir}/32x32/apps/ksm-rpm.png
#%{_icondir}/48x48/apps/ksm-rpm.png
#%{_icondir}/64x64/apps/ksm-rpm.png
#%{_icondir}/128x128/apps/ksm-rpm.png
#/usr/share/pixmaps/ksm-rpm.png

%docdir %{_man1dir}
%{_man1dir}/rpmchk.1.gz
%{_man1dir}/rpmdeps1.1.gz
%{_man1dir}/rpminfo.1.gz
%{_man1dir}/rpmman.1.gz
%{_man1dir}/rpmprovides.1.gz
%{_man1dir}/rpmrequires.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/ksmrpmd.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/sampleconf.conf && cp %{_confdir}/sampleconf.conf %{_confdir}/sampleconf.conf.rpmsave
#test -e %{_scnfdir}/sampleconf && cp %{_scnfdir}/sampleconf %{_scnfdir}/sampleconf.rpmsave

# disable sample daemon and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/sampled.service ]; then
#		systemctl stop sampled.service
#		systemctl disable sampled.service
#		rm %{_sysddir}/sampled.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1
#	insserv -r sampled > /dev/null 2>&1
#	rm -f %{_rcdir}/sampled
#	rm -f %{_sbindir}/rcsampled
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/ksmrpm.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# enable ksm-rpm daemon
#test -x %{_bindir}/toggleksm-rpm && %{_bindir}/toggleksm-rpm -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/ksm-rpm.directory \
#	/usr/share/applications/ksm-rpm.desktop \
#	/usr/share/applications/ksm-rpm-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - install KSM-RPM
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/ksmrpmd.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable ksmrpmd.service
#	echo "ksmrpmd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ksmrpmd within yast or manual with:"
#	echo "systemctl start ksmrpmd.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/ksmrpmd.rc %{_rcdir}/ksmrpmd
#	ln -sf %{_rcdir}/ksmrpmd %{_sbindir}/rcksmrpmd
#	insserv ksmrpmd > /dev/null 2>&1
#	echo "ksmrpmd is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start ksmrpmd within yast or manual with rcksmrpmd start"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.ksm-rpmrc with update-ksm-rpm"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.ksm-rpmrc'
#	updcmd="%{_bindir}/update-ksm-rpm -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.ksm-rpmrc with update-ksm-rpm"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/ksmrpm.conf && cp %{_confdir}/ksmrpm.conf %{_confdir}/ksmrpm.conf.rpmsave
	#test -e %{_scnfdir}/ksmrpm && cp %{_scnfdir}/ksmrpm %{_scnfdir}/ksmrpm.rpmsave

	# disable ksm-rpm daemon and stop ksmrpmd
	#test -x %{_bindir}/toggleksm-rpm && %{_bindir}/toggleksm-rpm -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/ksmrpmd && %{_rcdir}/ksmrpmd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/ksm-rpm.directory \
	#	/usr/share/applications/ksm-rpm.desktop \
	#	/usr/share/applications/ksm-rpm-admin.desktop

	# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-RPM
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/ksmrpmd.service ]; then
	#		systemctl stop ksmrpmd.service
	#		systemctl disable ksmrpmd.service
	#		rm %{_sysddir}/ksmrpmd.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#	test -x %{_rcdir}/ksmrpmd && %{_rcdir}/ksmrpmd stop > /dev/null 2>&1
	#	insserv -r ksmrpmd > /dev/null 2>&1
	#	rm -f %{_rcdir}/ksmrpmd
	#	rm -f %{_sbindir}/rcksmrpmd
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-rpm
#else							# upgrade package
fi
exit 0

%changelog
* Fri Mar 13 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.0.0
- Added rpmman.

* Fri Mar 13 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.1
- The docu of each program has been modified.

* Fri Nov 02 2018 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised.

* Fri Nov 02 2018 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- Following packages have been moved from package Utils:
  rpmchk
  rpmdeps1
  rpminfo
  rpmprovides
  rpmrequires
